from turtle import *
from random import randint
colormode(255)
speed(999999999)
hideturtle()

#defini le flocons
# Ce code provient de https://www.numworks.com/fr/professeurs/activites-pedagogiques/premiere/flocon/
def cote(longueur,niveau):
    if niveau==0:
        forward(longueur)
    else:
        cote(longueur/3,niveau-1)
        left(60)
        cote(longueur/3,niveau-1)
        right(120)
        cote(longueur/3,niveau-1)
        left(60)
        cote(longueur/3,niveau-1)

def flocon(longueur,niveau,x,y):
    width(1)
    penup()
    goto(x,y)
    pendown()
    for i in range(3):
        cote(longueur,niveau)
        right(120)

#defini l'arbre
#Ce code provient de https://my.numworks.com/python/cent20/arbre
def arbre(n,longueur,w,r1,g1,b1,r2,g2,b2):
  if n==0 :
    pencolor(r1,g1,b1)
    forward(longueur)
    backward(longueur)
    pencolor(r2,g2,b2)
  else:
    width(w) 
    forward(longueur/3)
    left(50) 
    arbre(n-1,longueur*2/3,w/1.2,r1,g1,b1,r2,g2,b2)
    right(2*50)
    arbre(n-1,longueur*2/3,w/1.2,r1,g1,b1,r2,g2,b2)
    left(50)
    backward(longueur/3)
 

#fond couleur random
color(randint(10,250),255,255)
begin_fill()
goto(-640,700)
pendown()
goto(640,700)
goto(640,-700)
goto(-640,-700)
goto(-640,700)
end_fill()

#montagne 1
goto(-640,230)
begin_fill()
color(randint(115,145),145,145)
setheading(0)
for i in range (10):
    for i in range (5):
        forward(20)
        right(2)
    for i in range (5):
        forward(10)
        left(2)
goto(640,-500)
goto(-640,-500)
goto(-640,250)
end_fill()

#arbre 1
penup()
goto(randint(-550,-450),randint(120,160))
pendown()
setheading(90)
color(75,randint(40,50),randint(0,20))
arbre(9,randint(50,90),randint(4,7),randint(130,180),randint(160,180),180,75,randint(40,50),randint(0,20))

#arbre 2
penup()
goto(randint(-450,-250),randint(120,160))
pendown()
setheading(90)
color(75,randint(40,50),randint(0,20))
arbre(9,randint(50,90),randint(4,7),randint(130,180),randint(160,180),180,75,randint(40,50),randint(0,20))



#montagne2
width(1)
penup()
goto(640,100)
pendown()
begin_fill()
color(randint(135,170),170,170)
setheading(180)
for i in range (10):
    for i in range (5):
        forward(25)
        left(2)
    for i in range (5):
        forward(10)
        right(2)
goto(-640,-500)
goto(640,-500)
goto(640,200)
end_fill()

##arbre 3
penup()
goto(randint(350,570),randint(40,80))
pendown()
setheading(90)
color(110,randint(60,80),randint(0,45))
arbre(10,randint(100,150),randint(4,7),randint(160,210),randint(200,230),230,110,randint(60,80),randint(0,45))

#arbre 4
penup()
goto(randint(10,250),randint(-20,50))
pendown()
setheading(90)
color(110,randint(60,80),randint(0,45))
arbre(10,randint(100,150),randint(4,7),randint(160,210),randint(200,230),230,110,randint(60,80),randint(0,45))


#montagne3
width(1)
penup()
goto(-640,-40)
pendown()
begin_fill()
color(randint(150,185),185,185)
setheading(0)
for i in range (10):
    for i in range (5):
        forward(30)
        right(2)
    for i in range (5):
        forward(10)
        left(2)
goto(640,-500)
goto(-640,-500)
goto(-640,150)
end_fill()


#arbre 5
penup()
goto(randint(-550,-200),randint(-300,-100))
pendown()
setheading(90)
color(150,randint(85,110),randint(0,50))
arbre(11,randint(150,250),randint(7,15),randint(150,230),randint(210,245),255,150,randint(85,110),randint(0,50))


#arbre 6
penup()
goto(randint(-100,250),randint(-300,-90))
pendown()
setheading(90)
color(150,randint(85,110),randint(0,50))
arbre(11,randint(150,350),randint(7,15),randint(150,230),randint(210,245),255,150,randint(85,110),randint(0,50))


#arbre 7
speed(999999)
penup()
goto(100,0)
pendown()
setheading(90) 
color(150,randint(85,110),randint(0,50))
arbre(10,randint(150,250),randint(7,15),randint(150,230),randint(210,245),255,150,randint(85,110),randint(0,50))

# nb random de flocons à des endroits, inclinaison, taille et couleur random
pendown()
for i in range (randint(30,45)):
    width(1)
    setheading(randint(0,360))
    color(randint(0, 220),randint(110, 240),255)
    begin_fill()
    flocon(randint(20,50),randint(3,5),randint(-639,639),randint(-310,310))
    end_fill()

